<template>
  <v-container class="fill-height container--fluid justify-center align-start">
    <v-dialog v-model="loading" persistent max-width="290">
      <v-progress-circular
        :size="100"
        indeterminate
        color="primary"
      ></v-progress-circular>
    </v-dialog>
    <error-dialog :dialog="dialog" error="Not Found" @close-dialog="closeDialog" />
    <v-row class="justify-center" style="max-width: 80vw">
      <h1 class="heading primary--text display-3">
        {{paste.title ? paste.title : 'Untitled'}}
      </h1>
    </v-row>
    <v-row class="justify-center" style="max-width: 80vw">
      <v-textarea
        outlined
        readonly
        :value="paste.content"
        rows="30"
        row-height="15"
        :hint="`${contentSize} bytes`"
      ></v-textarea>
    </v-row>
    <v-row class="justify-center">
      <p>Created At: {{paste.createdAt}}</p>
    </v-row>
  </v-container>
</template>

<script>
import { getById } from '../api';
import ErrorDialog from '../components/ErrorDialog.vue';

export default {
  name: 'paste',
  components: { ErrorDialog },
  data: () => ({
    id: '',
    dialog: false,
    loading: false,
    error: '',
    contentSize: 0,
    paste: {
      title: '',
      content: '',
      createdAt: '',
    },
  }),
  watch: {
    'paste.content': function (val) {
      this.contentSize = new Blob([val]).size;
    },
  },
  mounted() {
    this.id = this.$route.params.id;
    this.loading = true;
    getById(this.id)
      .then(({ data }) => {
        this.loading = false;
        this.paste = data;
      })
      .catch(() => {
        this.loading = false;
        this.dialog = true;
      });
  },
  methods: {
    closeDialog() {
      this.dialog = false;
      this.$router.push({ name: 'home' });
    },
  },
};
</script>
